CREATE TABLE jobs (
  job_id    smallint
    IDENTITY(1,1)
    PRIMARY KEY CLUSTERED,
  job_desc  varchar(50)   NOT NULL
    DEFAULT 'New Position - title not formalized yet',
  min_lvl   tinyint       NOT NULL
    CHECK (min_lvl >= 10),
  max_lvl   tinyint       NOT NULL
    CHECK (max_lvl <= 250)
)

CREATE TABLE publishers (
  pub_id     char(4)      NOT NULL 
    CONSTRAINT UPKCL_pubind PRIMARY KEY CLUSTERED
    CHECK (
      pub_id IN ('1389', '0736', '0877', '1622', '1756')
      OR pub_id LIKE '99[0-9][0-9]'),
  pub_name   varchar(40)  NULL,
  city       varchar(20)  NULL,
  state      char(2)      NULL,
  country    varchar(30)  NULL
    DEFAULT('USA')
)

CREATE TABLE employee (
  emp_id     empid
    CONSTRAINT PK_emp_id PRIMARY KEY NONCLUSTERED
    CONSTRAINT CK_emp_id CHECK (
      emp_id LIKE
        '[A-Z][A-Z][A-Z][1-9][0-9][0-9][0-9][0-9][FM]'
      or emp_id LIKE
        '[A-Z]-[A-Z][1-9][0-9][0-9][0-9][0-9][FM]'),
  fname      varchar(20)  NOT NULL,
  minit      char(1)      NULL,
  lname      varchar(30)  NOT NULL,
  job_id     smallint     NOT NULL
    DEFAULT 1
    REFERENCES jobs(job_id),
  job_lvl    tinyint
    DEFAULT 10,
  pub_id     char(4)      NOT NULL
    DEFAULT ('9952')
    REFERENCES publishers(pub_id),
  hire_date  datetime     NOT NULL
    DEFAULT (getdate())
)