IF object_id('dbo.sfn_MakeErrMsg') IS NOT NULL
  DROP FUNCTION dbo.sfn_MakeErrMsg
GO
CREATE FUNCTION dbo.sfn_MakeErrMsg
  (@source sysname, @ERR int,
   @custom_err_msg varchar(400) = '')
  RETURNS nvarchar(400)
AS
  BEGIN
    DECLARE  @error_msg nvarchar(400)

    IF @ERR IS NULL
      SET @ERR = 0

    IF @custom_err_msg IS NULL OR @custom_err_msg = ''
      SELECT @error_msg = @source + ': ' + description
          + ' (' + convert(varchar(5), error) + ')'
        FROM master.dbo.sysmessages
        WHERE error = @ERR
          AND msglangid = 1042  --ѱ ޽
    ELSE
      SET @error_msg = @source + ': ' + @custom_err_msg
        + ' (' + convert(varchar(5), @ERR) + ')'

    RETURN @error_msg
  END
GO