USE Northwind
GO
IF OBJECT_ID('dbo.tfn_Employees') IS NOT NULL
  DROP FUNCTION dbo.tfn_Employees
GO
CREATE FUNCTION dbo.tfn_Employees
  (@kind nvarchar(9))
  RETURNS @EmployeesTbl TABLE (
    EmployeeID   int          PRIMARY KEY,
    EmployeeName nvarchar(61) NOT NULL
  )
AS
  BEGIN
    IF @kind = 'ShortName'
      INSERT @EmployeesTbl
        SELECT EmployeeID, LastName
          FROM Employees
    ELSE IF @kind = 'LongName'
      INSERT @EmployeesTbl
        SELECT EmployeeID, (FirstName + ' ' + LastName)
          FROM Employees

    RETURN
  END
GO