USE tempdb
GO
-- CREATE TABLE author (
--   author_id int      IDENTITY PRIMARY KEY
-- , jumin     char(14) NOT NULL
-- , sex       bit      NOT NULL
-- )
-- GO
CREATE TABLE freelancer_author (
  author_id  smallint    NOT NULL
, royalty    int         NULL
)
GO
CREATE TABLE fulltime_author (
  author_id  smallint    NOT NULL
, yearly_pay int         NULL
)
GO
/* CASCADE DELETE Trigger ۵  Ʒ DRI ڸƮȭ */
--  ALTER TABLE freelancer_author
--    ADD FOREIGN KEY (author_id)
--      REFERENCES author
--        ON DELETE CASCADE
-- GO
--  
--  ALTER TABLE fulltime_author
--    ADD FOREIGN KEY (author_id)
--      REFERENCES author
--        ON DELETE CASCADE
-- GO
IF OBJECT_ID('tr_AuthorDelete') IS NOT NULL
  DROP TRIGGER tr_AuthorDelete
GO
CREATE TRIGGER tr_AuthorDelete
  on author
  for DELETE
as
  BEGIN TRAN
  DECLARE @ERR int

  DELETE freelancer_author
    FROM freelancer_author AS f
      JOIN deleted AS d
        ON f.author_id = d.author_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  DELETE fulltime_author
    FROM fulltime_author AS f
      JOIN deleted AS d
        ON f.author_id = d.author_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg =
    dbo.sfn_MakeErrMsg('tr_AuthorDelete', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO