USE tempdb
GO
CREATE TABLE author (
  author_id int      IDENTITY PRIMARY KEY
, jumin     char(14) NOT NULL
, sex       bit      NOT NULL
)
GO
IF OBJECT_ID('tr_AuthorInsert') IS NOT NULL
  DROP TRIGGER tr_AuthorInsert
GO
CREATE TRIGGER tr_AuthorInsert
  ON author
  FOR INSERT
AS
  BEGIN TRAN  --  Ұ!
  DECLARE @ERR int
  DECLARE @custom_err_msg varchar(400)
  DECLARE @jumin char(14), @jumin_sex char(1), @sex bit

  /*  Ե   Ȯ */    
  SELECT @jumin = jumin, @sex = sex
    FROM inserted

  SET @jumin_sex = SUBSTRING(@jumin, 8, 1)

  IF ( (@jumin_sex = '1' OR @jumin_sex = '3') AND @sex = 0 ) OR
     ( (@jumin_sex = '2' OR @jumin_sex = '4') AND @sex = 1 )
    BEGIN
      SET @custom_err_msg = 'ֹιȣ  ġ '
      GOTO ERROR
    END

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg =
    dbo.sfn_MakeErrMsg('tr_AuthorInsert', @ERR, @custom_err_msg)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO