/* 06-??_DDL_Fixed.sql
**
** Academy DB ϱ  DDL ũƮ
**
**   : ERwin
** : ձ
** : 030617
*/

USE master
IF EXISTS (SELECT * FROM sysdatabases WHERE name='Academy')
  DROP DATABASE Academy
GO
CREATE DATABASE Academy
GO
USE Academy
GO
 
----------------------- ü ⺻  Ģ  --------------------- 
CREATE RULE Rul_Date
  AS
    @date LIKE '[0-9][0-9]0[1-9]0[1-9]' OR
    @date LIKE '[0-9][0-9]0[1-9][1-2][0-9]' OR
    @date LIKE '[0-9][0-9]0[1-9]3[0-1]' OR
    @date LIKE '[0-9][0-9]1[0-2]0[1-9]' OR
    @date LIKE '[0-9][0-9]1[0-2][1-2][0-9]' OR
    @date LIKE '[0-9][0-9]1[0-2]3[0-1]'
GO
 
CREATE DEFAULT Dfs_0
  AS 0
GO
 
----------------------- ̺  ε  --------------------- 
CREATE TABLE course (
  course_id            int         IDENTITY,
  subject_id           smallint    NOT NULL,
  instructor_id        int         NOT NULL,
  capacity             tinyint     NOT NULL,
  textbook             varchar(50) NOT NULL,
  start_date           char(6)     NOT NULL,
  end_date             char(6)     NOT NULL,
  sugang_fee           int         NOT NULL,
  lecture_fee          int         NULL
)
GO
----06-??_DDL_Fixed.sql  ߰ : ----
ALTER TABLE course
  ADD CONSTRAINT ChkDates
    CHECK (end_date >= start_date)
GO  
----06-??_DDL_Fixed.sql  ߰ : ------
ALTER TABLE course
  ADD CONSTRAINT XPKcourse
    PRIMARY KEY NONCLUSTERED (course_id)
GO
CREATE INDEX XIF1course
  ON course (subject_id ASC)
GO
CREATE INDEX XIF2course
  ON course (instructor_id ASC)
GO
EXEC sp_bindrule Rul_Date, 'course.start_date'
EXEC sp_bindrule Rul_Date, 'course.end_date'
EXEC sp_bindefault Dfs_0, 'course.sugang_fee'
GO
 
CREATE TABLE instructor (
  instructor_id        int         IDENTITY,
  inst_name            varchar(10) NOT NULL,
  jumin                char(14)    NOT NULL
    CONSTRAINT Chk_Jumin
      CHECK (jumin LIKE '[0-9][0-9]0[1-9]0[1-9]-[1-4][0-9][0-9][0-9][0-9][0-9][0-9]'
        OR jumin LIKE '[0-9][0-9]0[1-9][1-2][0-9]-[1-4][0-9][0-9][0-9][0-9][0-9][0-9]'
        OR jumin LIKE '[0-9][0-9]0[1-9]3[0-1]-[1-4][0-9][0-9][0-9][0-9][0-9][0-9]'
        OR jumin LIKE '[0-9][0-9]1[0-2]0[1-9]-[1-4][0-9][0-9][0-9][0-9][0-9][0-9]'
        OR jumin LIKE '[0-9][0-9]1[0-2][1-2][0-9]-[1-4][0-9][0-9][0-9][0-9][0-9][0-9]'
        OR jumin LIKE '[0-9][0-9]1[0-2]3[0-1]-[1-4][0-9][0-9][0-9][0-9][0-9][0-9]'),
  grade                char(6)     NOT NULL
    CONSTRAINT DFT_5
      DEFAULT 5
    CONSTRAINT Chk_Grade
      CHECK (grade >= 1 AND grade <= 5),
  inst_phone           varchar(14) NULL
)
GO
ALTER TABLE instructor
  ADD CONSTRAINT XPKinstructor
    PRIMARY KEY NONCLUSTERED (instructor_id)
GO
CREATE UNIQUE INDEX XAK1instructor
  ON instructor (jumin ASC)
GO
CREATE INDEX XIE1instructor
  ON instructor (inst_name ASC)
GO
 
CREATE TABLE register (
  register_id          int     IDENTITY,
  student_id           int     NOT NULL,
  course_id            int     NOT NULL,
  discount_rate        tinyint NULL
    CONSTRAINT Chk_Discnt
      CHECK (discount_rate >= 0 AND discount_rate <= 50),
  reg_date             char(6) NULL,
  reg_price            int     NULL
)
GO
ALTER TABLE register
  ADD CONSTRAINT XPKregister
    PRIMARY KEY NONCLUSTERED (register_id)
GO
CREATE INDEX XIF1register
  ON register (student_id ASC)
GO
CREATE INDEX XIF2register
  ON register (course_id ASC)
GO
EXEC sp_bindrule Rul_Date, 'register.reg_date'
GO
 
CREATE TABLE student (
  student_id           int         IDENTITY,
  stud_name            varchar(10) NOT NULL,
  point                tinyint     NOT NULL
    CONSTRAINT Chk_Point
      CHECK (point >= 0 AND point <= 50),
  stud_phone           varchar(14) NULL,
  address              varchar(80) NULL
)
GO
ALTER TABLE student
  ADD CONSTRAINT XPKstudent
    PRIMARY KEY NONCLUSTERED (student_id)
GO
CREATE INDEX XIE1student
  ON student (stud_name ASC)
GO
EXEC sp_bindefault Dfs_0, 'student.point'
GO
 
CREATE TABLE subject (
  subject_id  smallint    IDENTITY,
  subj_name   varchar(50) NOT NULL
)
GO
ALTER TABLE subject
  ADD CONSTRAINT XPKsubject
    PRIMARY KEY NONCLUSTERED (subject_id)
GO
 
--------------------------- DRI ----------------------------
ALTER TABLE course
  ADD CONSTRAINT R_2
    FOREIGN KEY (instructor_id)
      REFERENCES instructor
GO
 
ALTER TABLE course
  ADD CONSTRAINT R_1
    FOREIGN KEY (subject_id)
      REFERENCES subject
        ON DELETE CASCADE
GO

ALTER TABLE register
  ADD CONSTRAINT R_4
    FOREIGN KEY (course_id)
      REFERENCES course
        ON DELETE CASCADE
GO

ALTER TABLE register
  ADD CONSTRAINT R_3
    FOREIGN KEY (student_id)
      REFERENCES student
GO

------------------------   , Ÿ -----------------------
/*  :
CREATE DATABASE μ 'Academy' ũ 0.75MB Ҵϴ Դϴ.
CREATE DATABASE μ 'Academy_log' ũ 0.49MB Ҵϴ Դϴ.
̺  Ģ εǾϴ.
̺  Ģ εǾϴ.
 ⺻ εǾϴ.
̺  Ģ εǾϴ.
 ⺻ εǾϴ.
*/

--EXEC master..xp_cmdshell 'DEL "G:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\Academy\06-23_DDL_Fixed_GDrv.bdf"'
--GO
--BACKUP DATABASE Academy TO DISK='G:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\Academy\06-23_DDL_Fixed_GDrv.bdf'
--GO

--DROP DATABASE Academy
--GO
--RESTORE DATABASE Academy FROM DISK = 'G:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\Academy\06-23_DDL_Fixed_GDrv.bdf'
