/* 07_??_FnSpTr.sql
**
** Academy DB   Լ,  ν  Ʈ 
** ϴ ũƮ
**
** ۼⰣ: 0306015~
** ۼ:  ձ
*/

USE Academy
GO

/* =======================   Լ  ====================== */

/* -------------------- sfn_MakeErrMsg --------------------
   ó ý  ȣ Է¹޾, ̵鿡   ռϿ
  ڿ ִ Į Լμ,   κ  ν Ǵ
  Ʈ RAISERROR  ǰ,  ø̼ǿ ޵.

  1. 
   1) ȭ  ޽ 
*/
--       DECLARE @ERR int
--       DECLARE @custom_err_msg varchar(400)
--       ...
--       IF ...
--         BEGIN
--           SET @custom_err_msg = '̷     ϴ.'
--           GOTO ERROR
--         END
--       ...
-- 
--     ERROR:
--       DECLARE @error_msg nvarchar(400)
--       SET @error_msg =
--         dbo.sfn_MakeErrMsg('msp_1', @ERR, @custom_err_msg)
--       RAISERROR( @error_msg, 16, 1 )
--       ...
--     GO
    
/* 2) ý  ޽  */
--       DECLARE @ERR int
--       ...
--       SET @ERR = @@ERROR
--       IF @ERR <> 0 GOTO ERROR
--       ...
--     ERROR:
--       DECLARE  @error_msg nvarchar(400)
--       SET @error_msg = dbo.sfn_MakeErrMsg('msp_1', @ERR, DEFAULT)
--       RAISERROR( @error_msg, 16, 1 )
/*
  2. ǻ  
     1) ȣ ݵ 'dbo.sfn_MakeErrMsg(...)'  ȣؾ .
     2)  ޽  ý Ķ(master.dbo.sysmessages )
        Evaluation  ʰ, '!' ǥõ(Evaluation  )

  3.  : 030602
*/

IF object_id('dbo.sfn_MakeErrMsg') IS NOT NULL
  DROP FUNCTION dbo.sfn_MakeErrMsg
GO
CREATE FUNCTION dbo.sfn_MakeErrMsg
  (@source sysname, @ERR int,
   @custom_err_msg varchar(400) = '')
  RETURNS nvarchar(400)
AS
  BEGIN
    DECLARE  @error_msg nvarchar(400)

    IF @ERR IS NULL
      SET @ERR = 0

    IF @custom_err_msg IS NULL OR @custom_err_msg = ''
      SELECT @error_msg = @source + ': ' + description
          + ' (' + convert(varchar(5), error) + ')'
        FROM master.dbo.sysmessages
        WHERE error = @ERR
          AND msglangid = 1042  --ѱ ޽
    ELSE
      SET @error_msg = @source + ': ' + @custom_err_msg
        + ' (' + convert(varchar(5), @ERR) + ')'

    RETURN @error_msg
  END
GO

/* =======================  ν  ======================= */

-- - - - - - - - - - - - - msp_CourseInsert - - - - - - - - - - - - - -
IF object_id('msp_CourseInsert') IS NOT NULL
  DROP PROC msp_CourseInsert
GO
CREATE PROC msp_CourseInsert (
  @subject_id     smallint
, @instructor_id  int
, @capacity       tinyint
, @textbook       varchar(50)
, @start_date     char(6)
, @end_date       char(6)
, @sugang_fee     int
)
AS
  BEGIN TRAN
  DECLARE @ERR int
  DECLARE @ID int    -- @@IDENTITY    

  /* ڵ ϴ  ( ڵ鵵 ). */
  /* lecture_fee NULL Ե */
  INSERT course (subject_id, instructor_id, capacity,
      textbook, start_date, end_date, sugang_fee)
    VALUES (@subject_id, @instructor_id, @capacity,
      @textbook, @start_date, @end_date, @sugang_fee)

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  SET @ID = @@IDENTITY  --   IDENTITY  

  /* ش    ⺻  : ش   */

  COMMIT TRAN
  RETURN @ID  -- IDENTITY  ȯ
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_CourseInsert', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_CourseUpdate ------------------
IF object_id('msp_CourseUpdate') IS NOT NULL
  DROP PROC msp_CourseUpdate
GO
CREATE PROC msp_CourseUpdate (
  @course_id       int           -- Ű
--  @subject_id    smallint      -- Ģ ȭ
--, @instructor_id int           -- Ģ ȭ
, @capacity        tinyint     = NULL
, @textbook        varchar(50) = NULL
--, @start_date    char(6)       -- Ģ ȭ
--, @end_date      char(6)       -- Ģ ȭ
--, @sugang_fee    int           -- Ģ ȭ
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  IF @capacity IS NOT NULL
    BEGIN
      UPDATE course
        SET capacity = @capacity
        WHERE course_id = @course_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  IF @textbook IS NOT NULL
    BEGIN
      UPDATE course
        SET textbook = @textbook
        WHERE course_id = @course_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_CourseUpdate', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_CourseDelete ------------------
IF object_id('msp_CourseDelete') IS NOT NULL
  DROP PROC msp_CourseDelete
GO
CREATE PROC msp_CourseDelete (
  @course_id  int   --  Ű
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  DELETE course
    WHERE course_id = @course_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_CourseDelete', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_CourseSelectAll ------------------
IF OBJECT_ID('msp_CourseSelectAll') IS NOT NULL
  DROP PROC msp_CourseSelectAll
GO
CREATE PROC msp_CourseSelectAll
AS
  SELECT *
    FROM course
    ORDER BY course_id
GO

----------------- msp_CourseSelectARow ------------------
IF OBJECT_ID('msp_CourseSelectARow ') IS NOT NULL
  DROP PROC msp_CourseSelectARow 
GO
CREATE PROC msp_CourseSelectARow  (
  @course_id int
)AS
  SELECT *
    FROM course
    WHERE course_id = @course_id
GO

-- - - - - - - - - - - - - msp_InstructorInsert - - - - - - - - - - - - - -
IF object_id('msp_InstructorInsert') IS NOT NULL
  DROP PROC msp_InstructorInsert
GO
CREATE PROC msp_InstructorInsert (
  @inst_name  varchar(10)
, @jumin      char(14)
, @inst_phone varchar(14)	= NULL
)
AS
  BEGIN TRAN
  DECLARE @ERR int
  DECLARE @ID int    -- @@IDENTITY    

  /* ڵ ϴ  ( ڵ鵵 ). */
  /* grade  ⺻ . */
  INSERT instructor (inst_name, jumin, grade, inst_phone)
    VALUES (@inst_name, @jumin, DEFAULT, @inst_phone)

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  SET @ID = @@IDENTITY  --   IDENTITY  

  /* ش    ⺻  : ش   */

  COMMIT TRAN
  RETURN @ID  -- IDENTITY  ȯ
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_InstructorInsert', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_InstructorUpdate ------------------
IF object_id('msp_InstructorUpdate') IS NOT NULL
  DROP PROC msp_InstructorUpdate
GO
CREATE PROC msp_InstructorUpdate (
  @instructor_id  int           -- Ű
, @inst_name      varchar(10)	= NULL
, @jumin          char(14)   	= NULL
, @inst_phone     varchar(14)	= NULL
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  IF @inst_name IS NOT NULL
    BEGIN
      UPDATE instructor
        SET inst_name = @inst_name
        WHERE instructor_id = @instructor_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  IF @jumin IS NOT NULL
    BEGIN
      UPDATE instructor
        SET jumin = @jumin
        WHERE instructor_id = @instructor_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  IF @inst_phone IS NOT NULL
    BEGIN
      UPDATE instructor
        SET inst_phone = @inst_phone
        WHERE instructor_id = @instructor_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_InstructorUpdate', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_InstructorDelete ------------------
IF object_id('msp_InstructorDelete') IS NOT NULL
  DROP PROC msp_InstructorDelete
GO
CREATE PROC msp_InstructorDelete (
  @instructor_id  int   --  Ű
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  DELETE instructor
    WHERE instructor_id = @instructor_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_InstructorDelete', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_InstructorSelectAll ------------------
IF OBJECT_ID('msp_InstructorSelectAll') IS NOT NULL
  DROP PROC msp_InstructorSelectAll
GO
CREATE PROC msp_InstructorSelectAll
AS
  SELECT *
    FROM instructor
    ORDER BY instructor_id
GO

----------------- msp_InstructorSelectARow ------------------
IF OBJECT_ID('msp_InstructorSelectARow ') IS NOT NULL
  DROP PROC msp_InstructorSelectARow 
GO
CREATE PROC msp_InstructorSelectARow  (
  @instructor_id int
)AS
  SELECT *
    FROM instructor
    WHERE instructor_id = @instructor_id
GO

-- - - - - - - - - - - - - msp_RegisterInsert - - - - - - - - - - - - - -
IF object_id('msp_RegisterInsert') IS NOT NULL
  DROP PROC msp_RegisterInsert
GO
CREATE PROC msp_RegisterInsert (
  @student_id  int
, @course_id   int
, @reg_date    char(6) = NULL
)
AS
  BEGIN TRAN
  DECLARE @ERR int
  DECLARE @ID int    -- @@IDENTITY    

  /* ڵ ϴ  ( ڵ鵵 ). */
  /* discount_rate, reg_price NULL Ե. */
  INSERT register (student_id, course_id, reg_date)
    VALUES (@student_id, @course_id, @reg_date)

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  SET @ID = @@IDENTITY  --   IDENTITY  

  /* ش    ⺻  : ش   */

  COMMIT TRAN
  RETURN @ID  -- IDENTITY  ȯ
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_RegisterInsert', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_RegisterUpdate ------------------
IF object_id('msp_RegisterUpdate') IS NOT NULL
  DROP PROC msp_RegisterUpdate
GO
CREATE PROC msp_RegisterUpdate (
  @register_id   int       --  Ű
--, @student_id  int       --  Ģ ȭ
--, @course_id   int       --  Ģ ȭ
, @reg_date      char(6) = NULL
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  IF @reg_date IS NOT NULL
    BEGIN
      UPDATE register
        SET reg_date = @reg_date
        WHERE register_id = @register_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_RegisterUpdate', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_RegisterDelete ------------------
IF object_id('msp_RegisterDelete') IS NOT NULL
  DROP PROC msp_RegisterDelete
GO
CREATE PROC msp_RegisterDelete (
  @register_id  int   --  Ű
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  DELETE register
    WHERE register_id = @register_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_RegisterDelete', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_RegisterSelectAll ------------------
IF OBJECT_ID('msp_RegisterSelectAll') IS NOT NULL
  DROP PROC msp_RegisterSelectAll
GO
CREATE PROC msp_RegisterSelectAll
AS
  SELECT *
    FROM register
    ORDER BY register_id
GO

----------------- msp_RegisterSelectARow ------------------
IF OBJECT_ID('msp_RegisterSelectARow ') IS NOT NULL
  DROP PROC msp_RegisterSelectARow 
GO
CREATE PROC msp_RegisterSelectARow  (
  @register_id int
)AS
  SELECT *
    FROM register
    WHERE register_id = @register_id
GO

-- - - - - - - - - - - - - msp_StudentInsert - - - - - - - - - - - - - -
IF object_id('msp_StudentInsert') IS NOT NULL
  DROP PROC msp_StudentInsert
GO
CREATE PROC msp_StudentInsert (
  @stud_name   varchar(10)
, @stud_phone  varchar(14) = NULL
, @address     varchar(80) = NULL
)
AS
  BEGIN TRAN
  DECLARE @ERR int
  DECLARE @ID  int  -- @@IDENTITY    

  /* ڵ ϴ  ( ڵ鵵 ). */
  /* point  ⺻ . */
  INSERT student (stud_name, point, stud_phone, address)
    VALUES (@stud_name, DEFAULT, @stud_phone, @address)

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  SET @ID = @@IDENTITY  --   IDENTITY  

  /* ش    ⺻  : ش   */

  COMMIT TRAN
  RETURN @ID  -- IDENTITY  ȯ
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_StudentInsert', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_StudentUpdate ------------------
IF object_id('msp_StudentUpdate') IS NOT NULL
  DROP PROC msp_StudentUpdate
GO
CREATE PROC msp_StudentUpdate (
  @student_id  int           -- Ű
, @stud_name   varchar(10) = NULL
, @stud_phone  varchar(14) = NULL
, @address     varchar(80) = NULL
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  IF @stud_name IS NOT NULL
    BEGIN
      UPDATE student
        SET stud_name = @stud_name
        WHERE student_id = @student_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  IF @stud_phone IS NOT NULL
    BEGIN
      UPDATE student
        SET stud_phone = @stud_phone
        WHERE student_id = @student_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  IF @address IS NOT NULL
    BEGIN
      UPDATE student
        SET address = @address
        WHERE student_id = @student_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_StudentUpdate', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_StudentDelete ------------------
IF object_id('msp_StudentDelete') IS NOT NULL
  DROP PROC msp_StudentDelete
GO
CREATE PROC msp_StudentDelete (
  @student_id  int   --  Ű
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  DELETE student
    WHERE student_id = @student_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_StudentDelete', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_StudentSelectAll ------------------
IF OBJECT_ID('msp_StudentSelectAll') IS NOT NULL
  DROP PROC msp_StudentSelectAll
GO
CREATE PROC msp_StudentSelectAll
AS
  SELECT *
    FROM student
    ORDER BY student_id
GO

----------------- msp_StudentSelectARow ------------------
IF OBJECT_ID('msp_StudentSelectARow ') IS NOT NULL
  DROP PROC msp_StudentSelectARow 
GO
CREATE PROC msp_StudentSelectARow  (
  @student_id  int
)AS
  SELECT *
    FROM student
    WHERE student_id = @student_id
GO

-- - - - - - - - - - - - - msp_SubjectInsert - - - - - - - - - - - - - -
IF object_id('msp_SubjectInsert') IS NOT NULL
  DROP PROC msp_SubjectInsert
GO
CREATE PROC msp_SubjectInsert (
  @subj_name varchar(50)
)
AS
  BEGIN TRAN
  DECLARE @ERR int
  DECLARE @ID  int  -- @@IDENTITY    

  /* ڵ ϴ  ( ڵ鵵 ). */
  INSERT subject (subj_name)
    VALUES (@subj_name)

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  SET @ID = @@IDENTITY  --   IDENTITY  

  /* ش    ⺻  : ش    */

  COMMIT TRAN
  RETURN @ID  -- IDENTITY  ȯ
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_SubjectInsert', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_SubjectUpdate ------------------
IF object_id('msp_SubjectUpdate') IS NOT NULL
  DROP PROC msp_SubjectUpdate
GO
CREATE PROC msp_SubjectUpdate (
  @subject_id  int           -- Ű
, @subj_name   varchar(50) = NULL
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  IF @subj_name IS NOT NULL
    BEGIN
      UPDATE subject
        SET subj_name = @subj_name
        WHERE subject_id = @subject_id

      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_SubjectUpdate', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_SubjectDelete ------------------
IF object_id('msp_SubjectDelete') IS NOT NULL
  DROP PROC msp_SubjectDelete
GO
CREATE PROC msp_SubjectDelete (
  @subject_id  int   --  Ű
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  DELETE subject
    WHERE subject_id = @subject_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_SubjectDelete', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_SubjectSelectAll ------------------
IF OBJECT_ID('msp_SubjectSelectAll') IS NOT NULL
  DROP PROC msp_SubjectSelectAll
GO
CREATE PROC msp_SubjectSelectAll
AS
  SELECT *
    FROM subject
    ORDER BY subject_id
GO

----------------- msp_SubjectSelectARow ------------------
IF OBJECT_ID('msp_SubjectSelectARow ') IS NOT NULL
  DROP PROC msp_SubjectSelectARow 
GO
CREATE PROC msp_SubjectSelectARow  (
  @subject_id  int
)AS
  SELECT *
    FROM subject
    WHERE subject_id = @subject_id
GO

/* =========================== Ʈ  =========================== */

/*-----------------------< tr_CourseInsert >-----------------------
[TR#1]
  1. lecture_fee = (50000 - ((instructor.grade - 1) * 10000))
       * 8Hr * (end_date - start_date + 1)  

[TR#2]
  1. ش (instructor_id) ڽ  ȸ
     (  հ;  Ե  ) N̶  ,
     instructor.grade   

        N>40 = 1, N>30 = 2, N>20 = 3, N>10 = 4, N>0 = 5
*/
IF OBJECT_ID('tr_CourseInsert') IS NOT NULL
  DROP TRIGGER tr_CourseInsert
GO
CREATE TRIGGER tr_CourseInsert
  ON course
  FOR INSERT
AS
  BEGIN TRAN
  DECLARE @ERR int  --, @custom_err_msg varchar(400)

  /*  Ե ࿡   */
  DECLARE @course_id int, @instructor_id int,
    @start_date char(6), @end_date char(6)
  SELECT @course_id = course_id, @instructor_id = instructor_id,
      @start_date = start_date, @end_date = end_date
    FROM inserted

  ---------- [TR#1] ----------
  /* lecture_fee = (50000 - ((instructor.grade - 1) * 10000))
       * 8Hr * (end_date - start_date + 1)   */

  -- instructor.grade   Ȯ
  DECLARE @grade tinyint
  SELECT @grade = grade
    FROM instructor
    WHERE instructor_id = @instructor_id

  --  Ե  lecture_fee  
  UPDATE course
    SET lecture_fee = (50000 - ((@grade - 1) * 10000)) * 8 * (1 +
      DATEDIFF(Day, CONVERT(datetime, start_date, 12),
        CONVERT(datetime, end_date, 12)) )
    WHERE course_id = @course_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  ---------- [TR#2] ----------
  /* ش (instructor_id) ڽ  ȸ
     (  հ;  Ե  ) N̶  ,
     instructor.grade   
        N>40 = 1, N>30 = 2, N>20 = 3, N>10 = 4, N>0 = 5 */

  -- N 
  DECLARE @N int
  SELECT @N = COUNT(*)
    FROM course
    WHERE instructor_id = @instructor_id

  -- instructor.grade 
  UPDATE instructor
    SET grade =
      CASE
        WHEN @N > 40 THEN 1
        WHEN @N > 30 THEN 2
        WHEN @N > 20 THEN 3
        WHEN @N > 10 THEN 4
        WHEN @N >  0 THEN 5
      END
    WHERE instructor_id = @instructor_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg =
    dbo.sfn_MakeErrMsg('tr_CourseInsert', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

/*-----------------------< tr_CourseDelete >-----------------------
[TR#1]
  1. ش (instructor_id) ڽ  ȸ
     (  հ;    ) N̶  ,
     instructor.grade   

        N>40 = 1, N>30 = 2, N>20 = 3, N>10 = 4, N>0 = 5

  ==> tr_CourseInsert [TR#2]  
*/
IF OBJECT_ID('tr_CourseDelete') IS NOT NULL
  DROP TRIGGER tr_CourseDelete
GO
CREATE TRIGGER tr_CourseDelete
  ON course
  FOR DELETE
AS
  BEGIN TRAN
  DECLARE @ERR int  --, @custom_err_msg varchar(400)

  /*   ࿡   */
  DECLARE @course_id int, @instructor_id int
  SELECT @course_id = course_id, @instructor_id = instructor_id
    FROM inserted

  ---------- [TR#1] ----------
  /* ش (instructor_id) ڽ  ȸ
     (  հ;    ) N̶  ,
     instructor.grade   
        N>40 = 1, N>30 = 2, N>20 = 3, N>10 = 4, N>0 = 5 */

  -- N 
  DECLARE @N int
  SELECT @N = COUNT(*)
    FROM course
    WHERE instructor_id = @instructor_id

  -- instructor.grade 
  UPDATE instructor
    SET grade =
      CASE
        WHEN @N > 40 THEN 1
        WHEN @N > 30 THEN 2
        WHEN @N > 20 THEN 3
        WHEN @N > 10 THEN 4
        WHEN @N >  0 THEN 5
      END
    WHERE instructor_id = @instructor_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg =
    dbo.sfn_MakeErrMsg('tr_CourseDelete', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

/*-----------------------< tr_RegisterInsert >-----------------------
[TR#1]
  1.  ο( course_id   ;  Ե  )
     (course.capacity) ٸ ѹ( ʰ)

[TR#2]
  1. discount_rate = student.point  
  2. student.point = student.point + 1 
     (, 50 ʰ  )
*/
IF OBJECT_ID('tr_RegisterInsert') IS NOT NULL
  DROP TRIGGER tr_RegisterInsert
GO
CREATE TRIGGER tr_RegisterInsert
  ON register
  FOR INSERT
AS
  BEGIN TRAN
  DECLARE @ERR int, @custom_err_msg varchar(400)

  /*  Ե ࿡   */
  DECLARE @register_id int, @student_id int, @course_id int
  SELECT @register_id = register_id, @student_id = student_id,
      @course_id = course_id
    FROM inserted

  ---------- [TR#1] ----------
  /*  ο( course_id   ;  Ե  )
     (course.capacity) ٸ ѹ( ʰ) */

  --  ο ľ
  DECLARE @reg_num int, @capacity tinyint
  SELECT @reg_num = COUNT(*)
    FROM register
    WHERE course_id = @course_id

  --  ľ
  SELECT @capacity = capacity
    FROM course
    WHERE course_id = @course_id

  --  ο  
  IF @reg_num > @capacity  -- ʰ
    BEGIN
      SET @custom_err_msg = ' ʰ!'
      GOTO ERROR
    END

  ---------- [TR#2] ----------
  /* 1. discount_rate = student.point   */

  -- student.point ľ
  DECLARE @point tinyint
  SELECT @point = point
    FROM student
    WHERE student_id = @student_id

  -- discount_rate 
  UPDATE register
    SET discount_rate = @point
    WHERE register_id = @register_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  /* 2. student.point = student.point + 1 
        (, 50 ʰ  ) */

  -- student.point 
  UPDATE student
    SET point =
      CASE
        WHEN @point < 50 THEN @point + 1
        ELSE 50
      END
    WHERE student_id = @student_id  

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg =
    dbo.sfn_MakeErrMsg('tr_RegisterInsert', @ERR, @custom_err_msg)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

/*-----------------------< tr_RegisterUpdate >-----------------------
[TR#1]
  1. reg_date NULL NOT NULL ̿  ŵǾٸ ѹ
     ( Ģ    )

[TR#2]
  1. discount_rate Ǵ reg_date ŵǾ,
     reg_date NOT NULL 

       reg_price = course.sugang_fee
         * (100 - discount_rate) / 100

      (  Ͻ   )
*/
IF OBJECT_ID('tr_RegisterUpdate') IS NOT NULL
  DROP TRIGGER tr_RegisterUpdate
GO
CREATE TRIGGER tr_RegisterUpdate
  ON register
  FOR UPDATE
AS
  IF NOT (UPDATE(discount_rate) OR UPDATE(reg_date))
    RETURN

  BEGIN TRAN
  DECLARE @ERR int, @custom_err_msg varchar(400)

  /*  /    */
  DECLARE @register_id int, @course_id int, @discount_rate tinyint,
    @reg_date0 char(6), @reg_date1 char(6)
  SELECT @reg_date0 = reg_date
    FROM deleted
  SELECT @register_id = register_id, @course_id = course_id,
      @discount_rate = discount_rate, @reg_date1 = reg_date
    FROM inserted

  ---------- [TR#1] ----------
  /* reg_date NULL NOT NULL ̿  ŵǾٸ
     ѹ( Ģ    ) */

  --  / reg_date   
  IF UPDATE(reg_date) AND
     NOT (@reg_date0 IS NULL AND @reg_date1 IS NOT NULL)
    BEGIN
      SET @custom_err_msg =
        ' (reg_date) NULL NOT NULL Ÿ ˴ϴ!'
      GOTO ERROR
    END

  ---------- [TR#2] ----------
  /* discount_rate Ǵ reg_date ŵǾ,
     reg_date NOT NULL 

       reg_price = course.sugang_fee
         * (100 - discount_rate) / 100

      (  Ͻ   )
 */
  DECLARE @sugang_fee int

  IF @reg_date1 IS NOT NULL
    BEGIN
      SELECT @sugang_fee = sugang_fee
        FROM course
        WHERE course_id = @course_id

      UPDATE register
        SET reg_price = @sugang_fee
          * (100 - @discount_rate) / 100
        WHERE register_id = @register_id

      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg =
    dbo.sfn_MakeErrMsg('tr_RegisterUpdate', @ERR, @custom_err_msg)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

/*-----------------------< tr_RegisterDelete >-----------------------
[TR#1]
  1. student.point = student.point - 1 
     (, 0 ̸  )
*/
IF OBJECT_ID('tr_RegisterDelete') IS NOT NULL
  DROP TRIGGER tr_RegisterDelete
GO
CREATE TRIGGER tr_RegisterDelete
  ON register
  FOR DELETE
AS
  BEGIN TRAN
  DECLARE @ERR int  --, @custom_err_msg varchar(400)

  /*   ࿡   */
  DECLARE @student_id int
  SELECT @student_id = student_id
    FROM deleted

  ---------- [TR#1] ----------
  /* student.point = student.point - 1 
     (, 0 ̸  ) */

  -- student.point ľ
  DECLARE @point tinyint
  SELECT @point = point
    FROM student
    WHERE student_id = @student_id

  -- student.point 
  UPDATE student
    SET point =
      CASE
        WHEN @point > 0 THEN @point - 1
        ELSE 0
      END
    WHERE student_id = @student_id  

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg =
    dbo.sfn_MakeErrMsg('tr_RegisterDelete', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

------------------------   , Ÿ -----------------------
--EXEC master..xp_cmdshell 'DEL "G:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\Academy\07-27_FnSpTr_GDrv.bdf"'
--GO
--BACKUP DATABASE Academy TO DISK='G:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\Academy\07-27_FnSpTr_GDrv.bdf'
--GO

--DROP DATABASE Academy
--GO
--RESTORE DATABASE Academy FROM DISK = 'G:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\Academy\07-27_FnSpTr_GDrv.bdf'
